﻿using System;
using System.ComponentModel;

namespace Dapfor.Wpf.Grid.PerfDemo
{
    //Objects of this class are displayed in the grid
    public class TestClass : INotifyPropertyChanged
    {
        #region Static PropertyChangedEventArgs

        private static readonly Random Random = new Random();

        //For performance reasons PropertyChangedEventArgs are declared as static fields. 
        //This prevents from creation an object per each notification
        private static readonly PropertyChangedEventArgs Value1EventArgs = new PropertyChangedEventArgs("Value1");
        private static readonly PropertyChangedEventArgs Value2EventArgs = new PropertyChangedEventArgs("Value2");
        private static readonly PropertyChangedEventArgs Value3EventArgs = new PropertyChangedEventArgs("Value3");
        private static readonly PropertyChangedEventArgs Value4EventArgs = new PropertyChangedEventArgs("Value4");
        private static readonly PropertyChangedEventArgs Value5EventArgs = new PropertyChangedEventArgs("Value5");
        private static readonly PropertyChangedEventArgs Value6EventArgs = new PropertyChangedEventArgs("Value6");
        private static readonly PropertyChangedEventArgs Value7EventArgs = new PropertyChangedEventArgs("Value7");
        private static readonly PropertyChangedEventArgs Value8EventArgs = new PropertyChangedEventArgs("Value8");
        private static readonly PropertyChangedEventArgs Value9EventArgs = new PropertyChangedEventArgs("Value9");
        private static readonly PropertyChangedEventArgs Value10EventArgs = new PropertyChangedEventArgs("Value10");

        #endregion

        #region Fields

        private int _value1;
        private int _value2;
        private int _value3;
        private int _value4;
        private int _value5;
        private int _value6;
        private int _value7;
        private int _value8;
        private int _value9;
        private int _value10;

        #endregion

        //Public properties
        public int Value1
        {
            get { return _value1; }
        }

        public int Value2
        {
            get { return _value2; }
        }

        public int Value3
        {
            get { return _value3; }
        }

        public int Value4
        {
            get { return _value4; }
        }

        public int Value5
        {
            get { return _value5; }
        }

        public int Value6
        {
            get { return _value6; }
        }

        public int Value7
        {
            get { return _value7; }
        }

        public int Value8
        {
            get { return _value8; }
        }

        public int Value9
        {
            get { return _value9; }
        }

        public int Value10
        {
            get { return _value10; }
        }

        //INotifyPropertyChanged implementation

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        public void UpdateRandomValue()
        {
            //Update random field with random value and fire a notification
            int newValue = Random.Next(0, 1000000);
            switch (Random.Next(0, 10))
            {
                case 0:
                    _value1 = newValue;
                    FirePropertyChanged(Value1EventArgs);
                    break;
                case 1:
                    _value2 = newValue;
                    FirePropertyChanged(Value2EventArgs);
                    break;
                case 2:
                    _value3 = newValue;
                    FirePropertyChanged(Value3EventArgs);
                    break;
                case 3:
                    _value4 = newValue;
                    FirePropertyChanged(Value4EventArgs);
                    break;
                case 4:
                    _value5 = newValue;
                    FirePropertyChanged(Value5EventArgs);
                    break;
                case 5:
                    _value6 = newValue;
                    FirePropertyChanged(Value6EventArgs);
                    break;
                case 6:
                    _value7 = newValue;
                    FirePropertyChanged(Value7EventArgs);
                    break;
                case 7:
                    _value8 = newValue;
                    FirePropertyChanged(Value8EventArgs);
                    break;
                case 8:
                    _value9 = newValue;
                    FirePropertyChanged(Value9EventArgs);
                    break;
                case 9:
                    _value10 = newValue;
                    FirePropertyChanged(Value10EventArgs);
                    break;
            }
        }

        private void FirePropertyChanged(PropertyChangedEventArgs args)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, args);
            }
        }
    }
}